#pragma once
#include "engineinterface.h"
#include "DXUTCamera.h"
#include <vector>


class App :
	public EngineInterface
{
	void openFile();
	void saveFile();

	LPDIRECT3DVERTEXBUFFER9 	quadVertexBuffer;
	struct QuadVertex{
		D3DXVECTOR3 pos;
		D3DXVECTOR3 tex;
	};

	LPDIRECT3DCUBETEXTURE9 environmentCube;


	LPD3DXEFFECT effect;
	LPD3DXMESH mesh;
	int nSubMeshes;
	std::vector<LPDIRECT3DTEXTURE9> textures;
	std::vector<std::string> textureFilenames;
	CFirstPersonCamera camera;
public:
	App(LPDIRECT3DDEVICE9 device);
	HRESULT createDefaultResources();
	HRESULT releaseDefaultResources();
	HRESULT createManagedResources();
	HRESULT releaseManagedResources();
	void processMessage( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	void animate(double dt, double t);
	void render();
};

